/************************************
  REVISION LOG ENTRY
  Revision By: Mihai Filimon
  Revised on 9/10/98 2:32:34 PM
  Comments: TranslateWindowStyle.h: interface for the CTranslateWindowStyle class.
 ************************************/

#if !defined(AFX_TRANSLATEWINDOWSTYLE_H__5CDA2671_4886_11D2_868C_0040055C08D9__INCLUDED_)
#define AFX_TRANSLATEWINDOWSTYLE_H__5CDA2671_4886_11D2_868C_0040055C08D9__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

struct MAP_STYLE
{
	DWORD	m_nStyle;
	LPCSTR	m_lpszStyle;
};

#define DEFINE_STYLE(wStyle)  { wStyle, #wStyle }
static const MAP_STYLE allStyles[] =
{
	// Insert here substitutions of styles. Need that for complete alghoritm
	DEFINE_STYLE(WS_OVERLAPPEDWINDOW),	// WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME | WS_MINIMIZEBOX | WS_MAXIMIZEBOX
	DEFINE_STYLE(WS_POPUPWINDOW),		// WS_POPUP | WS_BORDER | WS_SYSMENU
	DEFINE_STYLE(WS_CAPTION),			// WS_BORDER | WS_DLGFRAME
	// Normal styles
	DEFINE_STYLE(WS_OVERLAPPED),
	DEFINE_STYLE(WS_POPUP),
	DEFINE_STYLE(WS_CHILD),
	DEFINE_STYLE(WS_MINIMIZE),
	DEFINE_STYLE(WS_VISIBLE),
	DEFINE_STYLE(WS_DISABLED),
	DEFINE_STYLE(WS_CLIPSIBLINGS),
	DEFINE_STYLE(WS_CLIPCHILDREN),
	DEFINE_STYLE(WS_MAXIMIZE),
	DEFINE_STYLE(WS_BORDER),
	DEFINE_STYLE(WS_DLGFRAME),
	DEFINE_STYLE(WS_VSCROLL),
	DEFINE_STYLE(WS_HSCROLL),
	DEFINE_STYLE(WS_SYSMENU),
	DEFINE_STYLE(WS_THICKFRAME),
	DEFINE_STYLE(WS_GROUP),
	DEFINE_STYLE(WS_TABSTOP),
	DEFINE_STYLE(-1)
};

static const MAP_STYLE allExStyles[] =
{
	// Insert here substitutions of extended styles. Need that for complete alghoritm
	DEFINE_STYLE(WS_EX_OVERLAPPEDWINDOW),	// WS_EX_WINDOWEDGE | WS_EX_CLIENTEDGE
	DEFINE_STYLE(WS_EX_PALETTEWINDOW),		// WS_EX_WINDOWEDGE | WS_EX_TOOLWINDOW | WS_EX_TOPMOST
	// Normal extended styles
	DEFINE_STYLE(WS_EX_DLGMODALFRAME),
	DEFINE_STYLE(WS_EX_NOPARENTNOTIFY),
	DEFINE_STYLE(WS_EX_TOPMOST),
	DEFINE_STYLE(WS_EX_ACCEPTFILES),
	DEFINE_STYLE(WS_EX_TRANSPARENT),
	DEFINE_STYLE(WS_EX_MDICHILD),
	DEFINE_STYLE(WS_EX_TOOLWINDOW),
	DEFINE_STYLE(WS_EX_WINDOWEDGE),
	DEFINE_STYLE(WS_EX_CLIENTEDGE),
	DEFINE_STYLE(WS_EX_CONTEXTHELP),
	DEFINE_STYLE(WS_EX_RIGHT),
	DEFINE_STYLE(WS_EX_LEFT),
	DEFINE_STYLE(WS_EX_RTLREADING),
	DEFINE_STYLE(WS_EX_LTRREADING),
	DEFINE_STYLE(WS_THICKFRAME),
	DEFINE_STYLE(WS_EX_LEFTSCROLLBAR),
	DEFINE_STYLE(WS_EX_RIGHTSCROLLBAR),
	DEFINE_STYLE(WS_EX_CONTROLPARENT),
	DEFINE_STYLE(WS_EX_STATICEDGE),
	DEFINE_STYLE(WS_EX_APPWINDOW),
	DEFINE_STYLE(-1)
};

static const MAP_STYLE allClassStyles[] = 
{
	// If you have a subtitution of some class style, you need insert here.
	DEFINE_STYLE(CS_VREDRAW),
	DEFINE_STYLE(CS_HREDRAW),
	DEFINE_STYLE(CS_KEYCVTWINDOW),
	DEFINE_STYLE(CS_DBLCLKS),
	DEFINE_STYLE(CS_OWNDC),
	DEFINE_STYLE(CS_CLASSDC),
	DEFINE_STYLE(CS_PARENTDC),
	DEFINE_STYLE(CS_NOKEYCVT),
	DEFINE_STYLE(CS_NOCLOSE),
	DEFINE_STYLE(CS_SAVEBITS),
	DEFINE_STYLE(CS_BYTEALIGNCLIENT),
	DEFINE_STYLE(CS_BYTEALIGNWINDOW),
	DEFINE_STYLE(CS_GLOBALCLASS),
	DEFINE_STYLE(-1)
};

static const MAP_STYLE allDialogStyles[] = 
{
	DEFINE_STYLE(DS_ABSALIGN),
	DEFINE_STYLE(DS_SYSMODAL),
	DEFINE_STYLE(DS_LOCALEDIT),
	DEFINE_STYLE(DS_SETFONT),
	DEFINE_STYLE(DS_MODALFRAME),
	DEFINE_STYLE(DS_NOIDLEMSG),
	DEFINE_STYLE(DS_SETFOREGROUND),
	DEFINE_STYLE(DS_3DLOOK),
	DEFINE_STYLE(DS_FIXEDSYS),
	DEFINE_STYLE(DS_NOFAILCREATE),
	DEFINE_STYLE(DS_CONTROL),
	DEFINE_STYLE(DS_CENTER),
	DEFINE_STYLE(DS_CENTERMOUSE),
	DEFINE_STYLE(DS_CONTEXTHELP),
	DEFINE_STYLE(-1)
};

static const MAP_STYLE allHeaderStyles[] = 
{
	DEFINE_STYLE(HDS_HORZ),
	DEFINE_STYLE(HDS_BUTTONS),
	DEFINE_STYLE(HDS_HOTTRACK),
	DEFINE_STYLE(HDS_HIDDEN),
	DEFINE_STYLE(HDS_DRAGDROP),
	DEFINE_STYLE(HDS_FULLDRAG),
	DEFINE_STYLE(-1)
};

static const MAP_STYLE allListViewStyles[] = 
{
	DEFINE_STYLE(LVS_ICON),
	DEFINE_STYLE(LVS_REPORT),         
	DEFINE_STYLE(LVS_SMALLICON),
	DEFINE_STYLE(LVS_LIST),
	DEFINE_STYLE(LVS_TYPEMASK),
	DEFINE_STYLE(LVS_SINGLESEL),
	DEFINE_STYLE(LVS_SHOWSELALWAYS),
	DEFINE_STYLE(LVS_SORTASCENDING),
	DEFINE_STYLE(LVS_SORTDESCENDING),
	DEFINE_STYLE(LVS_SHAREIMAGELISTS),
	DEFINE_STYLE(LVS_NOLABELWRAP),
	DEFINE_STYLE(LVS_AUTOARRANGE),
	DEFINE_STYLE(LVS_EDITLABELS),
	DEFINE_STYLE(LVS_OWNERDATA),
	DEFINE_STYLE(LVS_NOSCROLL),
	DEFINE_STYLE(LVS_TYPESTYLEMASK),
	DEFINE_STYLE(LVS_ALIGNTOP),
	DEFINE_STYLE(LVS_ALIGNLEFT),
	DEFINE_STYLE(LVS_ALIGNMASK),
	DEFINE_STYLE(LVS_OWNERDRAWFIXED),
	DEFINE_STYLE(LVS_NOCOLUMNHEADER),
	DEFINE_STYLE(LVS_NOSORTHEADER),
	DEFINE_STYLE(-1)
};

static const MAP_STYLE allListViewStylesEx[] = 
{
	DEFINE_STYLE(LVS_EX_GRIDLINES),
	DEFINE_STYLE(LVS_EX_SUBITEMIMAGES),
	DEFINE_STYLE(LVS_EX_CHECKBOXES),
	DEFINE_STYLE(LVS_EX_TRACKSELECT),
	DEFINE_STYLE(LVS_EX_HEADERDRAGDROP),
	DEFINE_STYLE(LVS_EX_FULLROWSELECT),
	DEFINE_STYLE(LVS_EX_ONECLICKACTIVATE),
	DEFINE_STYLE(LVS_EX_TWOCLICKACTIVATE),
	DEFINE_STYLE(-1)
};

static const MAP_STYLE allToolTipStyles[] = 
{
	DEFINE_STYLE(TTS_ALWAYSTIP),
	DEFINE_STYLE(TTS_NOPREFIX),
	DEFINE_STYLE(-1)
};

static const MAP_STYLE allButtonStyles[] = 
{
	DEFINE_STYLE(BS_PUSHBUTTON),
	DEFINE_STYLE(BS_DEFPUSHBUTTON),
	DEFINE_STYLE(BS_CHECKBOX),
	DEFINE_STYLE(BS_AUTOCHECKBOX),
	DEFINE_STYLE(BS_RADIOBUTTON),
	DEFINE_STYLE(BS_3STATE),
	DEFINE_STYLE(BS_AUTO3STATE),
	DEFINE_STYLE(BS_GROUPBOX),
	DEFINE_STYLE(BS_USERBUTTON),
	DEFINE_STYLE(BS_AUTORADIOBUTTON),
	DEFINE_STYLE(BS_OWNERDRAW),
	DEFINE_STYLE(BS_LEFTTEXT),
	DEFINE_STYLE(BS_TEXT),
	DEFINE_STYLE(BS_ICON),
	DEFINE_STYLE(BS_BITMAP),
	DEFINE_STYLE(BS_LEFT),
	DEFINE_STYLE(BS_RIGHT),
	DEFINE_STYLE(BS_CENTER),
	DEFINE_STYLE(BS_TOP),
	DEFINE_STYLE(BS_BOTTOM),
	DEFINE_STYLE(BS_VCENTER),
	DEFINE_STYLE(BS_PUSHLIKE),
	DEFINE_STYLE(BS_MULTILINE),
	DEFINE_STYLE(BS_NOTIFY),
	DEFINE_STYLE(BS_FLAT),
	DEFINE_STYLE(-1)
};

static const MAP_STYLE allEditStyles[] = 
{
	DEFINE_STYLE(ES_LEFT),
	DEFINE_STYLE(ES_CENTER),
	DEFINE_STYLE(ES_RIGHT),
	DEFINE_STYLE(ES_MULTILINE),
	DEFINE_STYLE(ES_UPPERCASE),
	DEFINE_STYLE(ES_LOWERCASE),
	DEFINE_STYLE(ES_PASSWORD),
	DEFINE_STYLE(ES_AUTOVSCROLL),
	DEFINE_STYLE(ES_AUTOHSCROLL),
	DEFINE_STYLE(ES_NOHIDESEL),
	DEFINE_STYLE(ES_OEMCONVERT),
	DEFINE_STYLE(ES_READONLY),
	DEFINE_STYLE(ES_WANTRETURN),
	DEFINE_STYLE(ES_NUMBER),
	DEFINE_STYLE(-1)
};

static const MAP_STYLE allStaticStyles[] = 
{
	DEFINE_STYLE(SS_LEFT),
	DEFINE_STYLE(SS_CENTER),
	DEFINE_STYLE(SS_RIGHT),
	DEFINE_STYLE(SS_ICON),
	DEFINE_STYLE(SS_BLACKRECT),
	DEFINE_STYLE(SS_GRAYRECT),
	DEFINE_STYLE(SS_WHITERECT),
	DEFINE_STYLE(SS_BLACKFRAME),
	DEFINE_STYLE(SS_GRAYFRAME),
	DEFINE_STYLE(SS_WHITEFRAME),
	DEFINE_STYLE(SS_USERITEM),
	DEFINE_STYLE(SS_SIMPLE),
	DEFINE_STYLE(SS_LEFTNOWORDWRAP),
	DEFINE_STYLE(SS_OWNERDRAW),
	DEFINE_STYLE(SS_BITMAP),
	DEFINE_STYLE(SS_ENHMETAFILE),
	DEFINE_STYLE(SS_ETCHEDHORZ),
	DEFINE_STYLE(SS_ETCHEDVERT),
	DEFINE_STYLE(SS_ETCHEDFRAME),
	DEFINE_STYLE(SS_TYPEMASK),
	DEFINE_STYLE(SS_NOPREFIX),
	DEFINE_STYLE(SS_NOTIFY),
	DEFINE_STYLE(SS_CENTERIMAGE),
	DEFINE_STYLE(SS_RIGHTJUST),
	DEFINE_STYLE(SS_REALSIZEIMAGE),
	DEFINE_STYLE(SS_SUNKEN),
	DEFINE_STYLE(SS_ENDELLIPSIS),
	DEFINE_STYLE(SS_PATHELLIPSIS),
	DEFINE_STYLE(SS_WORDELLIPSIS),
	DEFINE_STYLE(SS_ELLIPSISMASK),
	DEFINE_STYLE(-1)
};

static const MAP_STYLE allTreeStyles[] = 
{
	DEFINE_STYLE(TVS_HASBUTTONS),
	DEFINE_STYLE(TVS_HASLINES),
	DEFINE_STYLE(TVS_LINESATROOT),
	DEFINE_STYLE(TVS_EDITLABELS),
	DEFINE_STYLE(TVS_DISABLEDRAGDROP),
	DEFINE_STYLE(TVS_SHOWSELALWAYS),
	DEFINE_STYLE(-1)
};

static const MAP_STYLE allTrackBarStyles[] = 
{
	DEFINE_STYLE(TBS_AUTOTICKS),
	DEFINE_STYLE(TBS_VERT),
	DEFINE_STYLE(TBS_HORZ),
	DEFINE_STYLE(TBS_TOP),
	DEFINE_STYLE(TBS_BOTTOM),
	DEFINE_STYLE(TBS_LEFT),
	DEFINE_STYLE(TBS_RIGHT),
	DEFINE_STYLE(TBS_BOTH),
	DEFINE_STYLE(TBS_NOTICKS),
	DEFINE_STYLE(TBS_ENABLESELRANGE),
	DEFINE_STYLE(TBS_FIXEDLENGTH),
	DEFINE_STYLE(TBS_NOTHUMB),
	DEFINE_STYLE(-1)
};

static const MAP_STYLE allListBoxStyles[] = 
{
	DEFINE_STYLE(LBS_STANDARD),  //(LBS_NOTIFY | LBS_SORT | WS_VSCROLL | WS_BORDER)
	DEFINE_STYLE(LBS_NOTIFY),
	DEFINE_STYLE(LBS_SORT),
	DEFINE_STYLE(LBS_NOREDRAW),
	DEFINE_STYLE(LBS_MULTIPLESEL),
	DEFINE_STYLE(LBS_OWNERDRAWFIXED),
	DEFINE_STYLE(LBS_OWNERDRAWVARIABLE),
	DEFINE_STYLE(LBS_HASSTRINGS),
	DEFINE_STYLE(LBS_USETABSTOPS),
	DEFINE_STYLE(LBS_NOINTEGRALHEIGHT),
	DEFINE_STYLE(LBS_MULTICOLUMN),
	DEFINE_STYLE(LBS_WANTKEYBOARDINPUT),
	DEFINE_STYLE(LBS_EXTENDEDSEL),
	DEFINE_STYLE(LBS_DISABLENOSCROLL),
	DEFINE_STYLE(LBS_NODATA),
	DEFINE_STYLE(LBS_NOSEL),
	DEFINE_STYLE(-1)
};

static const MAP_STYLE allComboBoxStyles[] = 
{
	DEFINE_STYLE(CBS_SIMPLE),
	DEFINE_STYLE(CBS_DROPDOWN),
	DEFINE_STYLE(CBS_DROPDOWNLIST),
	DEFINE_STYLE(CBS_OWNERDRAWFIXED),
	DEFINE_STYLE(CBS_OWNERDRAWVARIABLE),
	DEFINE_STYLE(CBS_AUTOHSCROLL),
	DEFINE_STYLE(CBS_OEMCONVERT),
	DEFINE_STYLE(CBS_SORT),
	DEFINE_STYLE(CBS_HASSTRINGS),
	DEFINE_STYLE(CBS_NOINTEGRALHEIGHT),
	DEFINE_STYLE(CBS_DISABLENOSCROLL),
	DEFINE_STYLE(CBS_UPPERCASE),
	DEFINE_STYLE(CBS_LOWERCASE),
	DEFINE_STYLE(-1)
};

static const MAP_STYLE allScrollStyles[] = 
{
	DEFINE_STYLE(SBS_HORZ),
	DEFINE_STYLE(SBS_VERT),
	DEFINE_STYLE(SBS_TOPALIGN),
	DEFINE_STYLE(SBS_LEFTALIGN),
	DEFINE_STYLE(SBS_BOTTOMALIGN),
	DEFINE_STYLE(SBS_RIGHTALIGN),
	DEFINE_STYLE(SBS_SIZEBOXTOPLEFTALIGN),
	DEFINE_STYLE(SBS_SIZEBOXBOTTOMRIGHTALIGN),
	DEFINE_STYLE(SBS_SIZEBOX),
	DEFINE_STYLE(SBS_SIZEGRIP),
	DEFINE_STYLE(-1)
};

static const MAP_STYLE allToolbarStyles[] = 
{
	DEFINE_STYLE(TBSTYLE_CHECKGROUP),      //(TBSTYLE_GROUP | TBSTYLE_CHECK)
	DEFINE_STYLE(TBSTYLE_BUTTON),
	DEFINE_STYLE(TBSTYLE_SEP),
	DEFINE_STYLE(TBSTYLE_CHECK),
	DEFINE_STYLE(TBSTYLE_GROUP),
	DEFINE_STYLE(TBSTYLE_DROPDOWN),
	DEFINE_STYLE(TBSTYLE_TOOLTIPS),
	DEFINE_STYLE(TBSTYLE_WRAPABLE),
	DEFINE_STYLE(TBSTYLE_ALTDRAG),
	DEFINE_STYLE(TBSTYLE_FLAT),
	DEFINE_STYLE(TBSTYLE_LIST),
	DEFINE_STYLE(TBSTYLE_CUSTOMERASE),
	DEFINE_STYLE(-1)
};

static const MAP_STYLE allStatusBarStyles[] = 
{
	DEFINE_STYLE(CBRS_LEFT),			//(CBRS_ALIGN_LEFT|CBRS_BORDER_RIGHT)
	DEFINE_STYLE(CBRS_TOP),				//(CBRS_ALIGN_TOP|CBRS_BORDER_BOTTOM)
	DEFINE_STYLE(CBRS_RIGHT),			//(CBRS_ALIGN_RIGHT|CBRS_BORDER_LEFT)
	DEFINE_STYLE(CBRS_BOTTOM),			//(CBRS_ALIGN_BOTTOM|CBRS_BORDER_TOP)
	DEFINE_STYLE(CBRS_ORIENT_HORZ),		//(CBRS_ALIGN_TOP|CBRS_ALIGN_BOTTOM)
	DEFINE_STYLE(CBRS_ORIENT_VERT),		//(CBRS_ALIGN_LEFT|CBRS_ALIGN_RIGHT)
	DEFINE_STYLE(CBRS_ORIENT_ANY),		//(CBRS_ORIENT_HORZ|CBRS_ORIENT_VERT)
	DEFINE_STYLE(CBRS_ALIGN_LEFT),
	DEFINE_STYLE(CBRS_ALIGN_TOP),
	DEFINE_STYLE(CBRS_ALIGN_RIGHT),
	DEFINE_STYLE(CBRS_ALIGN_BOTTOM),
	DEFINE_STYLE(CBRS_ALIGN_ANY),
	DEFINE_STYLE(CBRS_BORDER_LEFT),
	DEFINE_STYLE(CBRS_BORDER_TOP),
	DEFINE_STYLE(CBRS_BORDER_RIGHT),
	DEFINE_STYLE(CBRS_BORDER_BOTTOM),
	DEFINE_STYLE(CBRS_BORDER_ANY),
	DEFINE_STYLE(CBRS_TOOLTIPS),
	DEFINE_STYLE(CBRS_FLYBY),
	DEFINE_STYLE(CBRS_FLOAT_MULTI),
	DEFINE_STYLE(CBRS_BORDER_3D),
	DEFINE_STYLE(CBRS_HIDE_INPLACE),
	DEFINE_STYLE(CBRS_SIZE_DYNAMIC),
	DEFINE_STYLE(CBRS_SIZE_FIXED),
	DEFINE_STYLE(CBRS_FLOATING),
	DEFINE_STYLE(CBRS_ALL),
	DEFINE_STYLE(CBRS_NOALIGN),
	DEFINE_STYLE(-1)
};
	
static const MAP_STYLE allTabControlStyles[] = 
{
	DEFINE_STYLE(TCS_MULTILINE),
	DEFINE_STYLE(-1)
};

struct SMapKnownWindows
{
		// This structure stores in m_mapKnownWindows references to arrays of window class styles.
		// Now I put particulary style of dialog as #32770
	CMapStringToPtr m_mapKnownWindowsStyle;
	CMapStringToPtr m_mapKnownWindowsStyleEx;
	CMapStringToPtr m_mapKnownWindowsStyleClass;
	SMapKnownWindows()
	{
		m_mapKnownWindowsStyle[_T("#32770")] = (void*)allDialogStyles;
		m_mapKnownWindowsStyle[_T("button")] = (void*)allButtonStyles;
		m_mapKnownWindowsStyle[_T("listbox")] = (void*)allListBoxStyles;
		m_mapKnownWindowsStyle[_T("combobox")] = (void*)allComboBoxStyles;
		m_mapKnownWindowsStyle[_T("edit")] = (void*)allEditStyles;
		m_mapKnownWindowsStyle[_T("static")] = (void*)allStaticStyles;
		m_mapKnownWindowsStyle[_T("sysheader32")] = (void*)allHeaderStyles;
		m_mapKnownWindowsStyle[_T("syslistview32")] = (void*)allListViewStyles;
		 m_mapKnownWindowsStyleEx[_T("syslistview32")] = (void*)allListViewStylesEx;
		m_mapKnownWindowsStyle[_T("systreeview32")] = (void*)allTreeStyles;
		m_mapKnownWindowsStyle[_T("systabcontrol32")] = (void*)allTabControlStyles;
		m_mapKnownWindowsStyle[_T("tooltips_class32")] = (void*)allToolTipStyles;
		m_mapKnownWindowsStyle[_T("scrollbar")] = (void*)allScrollStyles;
		m_mapKnownWindowsStyle[_T("toolbarwindow32")] = (void*)allToolbarStyles;
		m_mapKnownWindowsStyle[_T("msctls_statusbar32")] = (void*)allStatusBarStyles;
		m_mapKnownWindowsStyle[_T("msctls_trackbar32")] = (void*)allTrackBarStyles;
	}
};

class CTranslatorWindowStyle  
{
protected:
	CMapStringToPtr* m_mapUnknowStyles;
	virtual CString TranslateUnknownStyle(CWnd* pWnd, DWORD nStyle);
	static SMapKnownWindows m_strWindowsClasses;
	// Need for Translate funcction, to store the last settings of Set... functions
	MAP_STYLE* m_mapLastStyles;
	DWORD m_nLastStyle;
	CWnd* m_pWnd;
	// Member variables.
	DWORD m_nStyle;
	DWORD m_nExStyle;
	DWORD m_nClassStyle;
	// Called this function by public function Translate
	CString TranslateStyle( MAP_STYLE* pMapStyles, DWORD nStyle , DWORD* pUnsolvedStyle = NULL);
public:
	static CString GetWindowClassName(CWnd* pWnd);
	virtual CString Translate();
	virtual DWORD SetStyle(DWORD nStyle);
	virtual DWORD SetExStyle(DWORD nExStyle);
	virtual DWORD SetClassStyle(DWORD nClassStyle);
	virtual DWORD SetStyle(CWnd* pWnd, DWORD nStyle = 0);
	virtual DWORD SetExStyle(CWnd* pWnd, DWORD nStyle = 0);
	virtual DWORD SetClassStyle(CWnd* pWnd, DWORD nStyle = 0);
	CTranslatorWindowStyle();
	virtual ~CTranslatorWindowStyle();

};

#endif // !defined(AFX_TRANSLATEWINDOWSTYLE_H__5CDA2671_4886_11D2_868C_0040055C08D9__INCLUDED_)
